--- origsrc/ocaml-4.14.0/runtime/Makefile	2022-03-28 08:27:36.000000000 -0400
+++ src/ocaml-4.14.0/runtime/Makefile	2022-07-10 22:37:06.338715000 -0400
@@ -74,9 +74,9 @@
 ifeq "$(UNIX_OR_WIN32)" "unix"
 ifeq "$(SUPPORTS_SHARED_LIBRARIES)" "true"
 BYTECODE_STATIC_LIBRARIES += libcamlrun_pic.$(A)
-BYTECODE_SHARED_LIBRARIES += libcamlrun_shared.$(SO)
+BYTECODE_SHARED_LIBRARIES += libcamlrun_shared.dll.a
 NATIVE_STATIC_LIBRARIES += libasmrun_pic.$(A)
-NATIVE_SHARED_LIBRARIES += libasmrun_shared.$(SO)
+NATIVE_SHARED_LIBRARIES += libasmrun_shared.dll.a
 endif
 endif
 
@@ -164,6 +164,7 @@
 ifneq "$(BYTECODE_SHARED_LIBRARIES)" ""
 	$(INSTALL_PROG) $(BYTECODE_SHARED_LIBRARIES) "$(INSTALL_LIBDIR)"
 endif
+	$(INSTALL_PROG) cygasmrun_shared.dll cygcamlrun_shared.dll "$(INSTALL_BINDIR)"
 	mkdir -p "$(INSTALL_INCDIR)"
 	$(INSTALL_DATA) caml/domain_state.tbl caml/*.h "$(INSTALL_INCDIR)"
 
@@ -294,6 +295,9 @@
 libcamlrun_shared.$(SO): $(libcamlrunpic_OBJECTS)
 	$(MKDLL) -o $@ $^ $(BYTECCLIBS)
 
+libcamlrun_shared.dll.a: $(libcamlrunpic_OBJECTS)
+	$(MKDLL) -o cygcamlrun_shared.dll -link -Wl,--out-implib,$@ $^ $(BYTECCLIBS)
+
 libasmrun.$(A): $(libasmrun_OBJECTS)
 	$(call MKLIB,$@, $^)
 
@@ -309,6 +313,9 @@
 libasmrun_shared.$(SO): $(libasmrunpic_OBJECTS)
 	$(MKDLL) -o $@ $^ $(NATIVECCLIBS)
 
+libasmrun_shared.dll.a: $(libasmrunpic_OBJECTS)
+	$(MKDLL) -o cygasmrun_shared.dll -link -Wl,--out-implib,$@ $^ $(BYTECCLIBS)
+
 # Target-specific preprocessor and compiler flags
 
 %.bd.$(O): OC_CPPFLAGS += $(OC_DEBUG_CPPFLAGS)
